// SPDX-FileCopyrightText: 2023 Olivier Charvin <git@olivier.pfad.fr>
//
// SPDX-License-Identifier: EUPL-1.2+
// Code generated by code.pfad.fr/swift/internal/cmd/bic-generate DO NOT EDIT.

// package bic computes the BIC from an IBAN (for supported countries).
package bic

import "code.pfad.fr/swift"

// FromIBAN returns the BIC from an IBAN.
// If the BIC cannot be computed, it returns an empty BIC. Supported country codes:
//
//   - AT (Austria)
//   - BE (Belgium)
//   - CH (Switzerland)
//   - DE (Germany)
//   - ES (Spain)
//   - FR (France)
//   - LI (Liechtenstein)
//   - LU (Luxembourg)
//   - MC (Monaco)
//   - NL (Netherlands)
func FromIBAN(iban swift.IBAN) swift.BIC {
	switch iban.CountryCode {
	case "AT":
		if len(iban.BBAN) >= 5 {
			return atBLZtoBIC[iban.BBAN[:5]]
		}
	case "BE":
		if len(iban.BBAN) >= 3 {
			return beBLZtoBIC[iban.BBAN[:3]]
		}
	case "CH":
		if len(iban.BBAN) >= 5 {
			return chBLZtoBIC[iban.BBAN[:5]]
		}
	case "DE":
		if len(iban.BBAN) >= 8 {
			return deBLZtoBIC[iban.BBAN[:8]]
		}
	case "ES":
		if len(iban.BBAN) >= 4 {
			return esBLZtoBIC[iban.BBAN[:4]]
		}
	case "FR":
		if len(iban.BBAN) >= 5 {
			return frBLZtoBIC[iban.BBAN[:5]]
		}
	case "LI":
		if len(iban.BBAN) >= 5 {
			return liBLZtoBIC[iban.BBAN[:5]]
		}
	case "LU":
		if len(iban.BBAN) >= 3 {
			return luBLZtoBIC[iban.BBAN[:3]]
		}
	case "MC":
		if len(iban.BBAN) >= 10 {
			return mcBLZtoBIC[iban.BBAN[:10]]
		}
	case "NL":
		if len(iban.BBAN) >= 4 {
			return nlBLZtoBIC[iban.BBAN[:4]]
		}
	}

	return swift.BIC{}
}
